#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN A0


// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(24, PIN, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.

void setup() {
  // This is for Trinket 5V 16MHz, you can remove these three lines if you are not using a Trinket
  #if defined (__AVR_ATtiny85__)
    if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
  #endif
  // End of trinket special code
  
  pinMode(3, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);

  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  //start up color
  delay(10);
  for(int i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, 255, 0, 255, 0);
  }
  strip.setBrightness(25);
  
  
  for(int i=1; i<125;i++)
  {
    //5 second intro
    strip.setBrightness(i);
    strip.show();
    set_pwm_m1(i/2);
    delay(100);
  }
  for(int j=0; j<256; j++) {
    for(int i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((j) & 255));  //(i+j)
    }
    strip.show();
  }
  /* 
  set_pwm_m1(50);
  strip.setBrightness(25);
  strip.show();
  delay(2000);
  strip.setBrightness(50);
  strip.show();
  delay(2000);
  strip.setBrightness(75);
  strip.show();
  delay(2000);
  strip.setBrightness(100);;
  strip.show();
  delay(2000);
  //strip.setBrightness(100);
  */
}

void loop() {
 
  rainbow(100);
  //delay(200);
  }


void rainbow(uint8_t wait) {
  uint16_t i, j, k;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((j) & 255));  //(i+j)
    }
    strip.show();
    k = j+50;
    if(j<125)
      {
        set_pwm_m2((256-j)/3.5);
      }
    else
      {
        set_pwm_m2(j/3.5);
      }
    delay(wait);
  }
}


void set_pwm_m1(int p){
  analogWrite(3, p);
  analogWrite(5, p);
  analogWrite(6, p);
}
void set_pwm_m2(int p){
  analogWrite(9, p);
  analogWrite(10, p);
  analogWrite(11, p);
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}

